--[[
	Due to the fact that not every locale is going to use the same type of definitions or acronyms, each one is it's own module.
	Sadly use of the WoWAce-CurseForge Loclization App is not viable

]]--


--local AddonParent = LibStub("AceAddon-3.0"):GetAddon("AcronymGuide")
--local module = AddonParent:NewModule("enUS Def File")

if GetLocale() ~= "enUS" then return end

local AcronymGuide = _G.AcronymGuide
local def

--function module:OnEnable()
local function enUS_Def(self)
	for i = 1, #def do
		self:AddDefinition( def[i] )
	end
end
table.insert(AcronymGuide.PlayerLoginFunc, enUS_Def)
--[[
	Conventions:
{"<Unique Identifier>", "<Regex>", "Link Text", "<Title and Description>", ... }

	The "<Unique Identifier>" will often be the Acronym itself or a variation.
	Keep in mid that the "<Regex>" is used by gsub().
	"<LinkText>" is that the end user sees, this will often be the Acronym properly cased or with dots (.) IE:  "D.P.S" or "L.F.G". No "[]" required.
		Be nice with the Link text, the end user sees this and we don't want to be obseen by giving them the whole thing or unnessisarily making the link text long.
	"<Title and Description>" is just that. The Properly spelled out acronym with each letter in the acronym capitilized and seperated from the description by "\n".

	smaller acronyms go lower in order.
	
	common fillter pieces
	"[%. ]*"	--matches a . or " " optionally in the middle
	"%s?" 		--optional space
	"
	
]]--

def = {	--Start of Definition File
--For Example
{"LFG", 	"[lL][fF][gG]", "LFG", "Looking For Group", "Meaning that this player is seeking others to join them in a party for some event"},

---------------
--- Commerce and Trade
---------------

{"WTB", 	"[wW][tT][bB]", "WTB", "Want To Buy", "Indicating this person is seeking to purchace or aquire the following item or thing."},
{"WTC", 	"[wW][tT][cC]", "WTC", "Want To Craft", },
{"WTS", 	"[wW][tT][sS]", "WTS", "Wants To Sell"},
{"LFW", 	"[lL][fF][wW]", "LFW", "Looking for Work", "Usualy found with a tradeskill link afterwards"},
{"PST", 	"[pP][sS][tT]", "PST", "Please Send a Tell"},

---------------
--- Grouping and Instancing
--------------
--WOTLK~~~~~~~~~~~~~~~~~~~~~~~~
	--Raids
		--Nax
{"h-nax", 	"25[%.%- ]*[mM][aA][nN][%.%- ]*[nN][aA][xX]+", "H-Nax", "Naxxramas"},
{"h-nax1", 	"[hH][%.%- ]*[nN][aA][xX]+", "H-Nax", "Naxxramas"},
{"r-nax", 	"[nN][aA][xX]+", "Nax", "Naxxramas"},

		--OS
{"h-OS", 	"25[%.%- ]*[mM][aA][nN][%.%- ]*[oO][sS]", "H-OS", "Obsidian Sanctum", "A 10-25 Man Raid Instance in Dragon Blight"},
{"h-OS1", 	"[hH][%.%- ]*[oO][sS", "HOS", "Obsidian Sanctum", "A 10-25 Man Raid Instance in Dragon Blight", "  Also could be Normal Halls of Stone."},
{"r-OS", 	"[oO][sS]", "OS", "Obsidian Sanctum", "A 10-25 Man Raid Instance in Dragon Blight"},
		--Mally

		--VoA
{"VoA1", 	"25[%.%- ]*[mM][aA][nN][%.%- ]*[vV][oO][aA]", "H-VoA", "Heroic: Vault of Archavon", "A small raid instance in Wintergrasp"},
{"VoA2", 	"[hH][%.%- ]*[vV][oO][aA]", "H-VoA", "Heroic: Vault of Archavon", "A small raid instance in Wintergrasp"},
{"VoA2", 	"[vV][oO][aA]", "VoA", "Vault of Archavon", "A small raid instance in Wintergrasp"},
		--Arc
{"VoA3", 	"25[%.%- ]*[mM][aA][nN][%.%- ]*[aA][rR][cC]", "Arc", "Vault of Archavon", "A small raid instance in Wintergrasp"},
{"VoA3", 	"[hH][%.%- ]*[aA][rR][cC]", "Arc", "Vault of Archavon", "A small raid instance in Wintergrasp", "Also could be 'Arcatraz', a lvl 70 (BC) instance in Outland"},
{"VoA3", 	"[aA][rR][cC]", "Arc", "Vault of Archavon", "A small raid instance in Wintergrasp", "Also could be 'Arcatraz', a lvl 70 (BC) instance in Outland"},
		--Valut
{"VoA4", 	"25[%.%- ]*[mM][aA][nN][%.%- ]*[vV][aA][uU][lL][tT]", "H-VoA", "Heroic: Vault of Archavon", "A small raid instance in Wintergrasp"},
{"VoA5", 	"[hH]%s+[vV][aA][uU][lL][tT]", "H-VoA", "Heroic: Vault of Archavon", "A small raid instance in Wintergrasp"},
{"VoA6", 	"[vV][aA][uU][lL][tT]", "VoA", "Vault of Archavon", "A small raid instance in Wintergrasp"},
		--PvP Event
{"WG-Event",	"[wW][gG]", 	"WG",	"Winter Grasp", "A PvP Zone in Northrend.", "This May also refer to Valt of Arcavon, a 10 & 25man Raid Instance there."},


	--North Rend Instances, Heroic's Must Come first in the chain
		--Nexus
{"h-Nexus",	"[hH][%.%- ]*[nN][eE][xX][uU]?[sS]?", "H-Nexus", "Heroic Nexus"},
{"r-Nexus",	"[nN][eE][xX][uU]?[sS]?", "Nexus", "Nexus", "An level 70 Instance in Borean Tundra"},
		--Oculus
		
		--DTK
{"h-DTK", 	"[hH][%.%- ]*[dD][tT][kK]", 	"H-DTK", "Heroic Drak'Tharon Keep"},
{"r-DTK", 	"[dD][tT][kK]", "DTK", 	"Drak'Tharon Keep"},

		--Gundrak
		
		
		
		--Ulduar
{"h-hos",	"[hH][%.%- ]*[hH][oO][sS]", 	"H-HoS", "Heroic Halls of Stone"},
{"r-hos",	"[hH][oO][sS]", 	"HoS", "Regular Halls of Stone"},

		--Utgard
{"h-UK",	"[hH][%.%- ]*[uU][kK]", "H-UK", "Hoeric: Utgard Keep"},
{"r-UK",	"[uU][kK]", "UK", "Utgard Keep"},
		
		--Azjol
{"h-AN", 	"[hH][%.%- ]*[aA][nN]", "H-AN", "Heroic: Azjol-Nerub", },
---{"r-AN", 	"[aA][nN]", "AN", "Azjol-Nerub", "Could also be just the word 'an'"},	--Not sure about this one might not include it really.
{"h-OK",	"[hH][%.%- ]*[oO][kK]", "H-OK", "Heroic Ahn'Kahet: 'The Old Kindom'", "Just refered to as 'Old Kingdom'"},	--Not sure about this one either.
--{"r-OK",	"[oO][kK]", "H-OK", "Ahn'Kahet: 'The Old Kindom'", "Just refered to as 'Old Kingdom'", "Might also be just the word 'ok', as in a reply"}, --Not sure about this one either.
		
		--CoT
{"h-CoS", 	"[hH][%.%- ]*[cC][oO][sS]", "H-CoS", "4th Wing of Caverns of Time added in Wrath"},
{"h-CoS", 	"[cC][oO][sS]", "CoS", "4th Wing of Caverns of Time added in Wrath"},
{"strat",	"[sS][tT][rR][aA][tT]",	"Strat", "Strategie", "Also could be 'Stratholme', an old world 5man instance", " Also, Culling of Stratholme, a Wrath 5man Instance"},	--to be modified as needed.
{"udStrat",	"[uU][dD][ -]?[sS][tT][rR][aA][tT][hH]?", "UD-Strath", "Un-Dead Stratholme", "Specifically the Eastern Portion of Stratholme"},
{"liveStrath",	"[lL][iI][vV][eE][ -]?[sS][tT][rR][aA][tT][hH]?", "Live-Strath", "Live Stratholme", "Specifically the 'North' Western Part of Stratholme, also called Scarlet or West Strath"},

		--VH
{"h-VH", 	"[hH][%.%- ]*[vV][hH]", "H-VH", "Heroic Violet Hold",},
{"r-VH", 	"[vV][hH]", "VH", "Violet Hold"},

{"SotA", 	"[sS][oO][tT][aA]", "Strand Of The Ancients", "A 20man Battleground introduced in Wrath"},

--BC~~~~~~~~~~~~~~~~~~~~~
{"BF-Instance",	"[bB][fF]", 	"BF", "Blood Furnace", "The Blood Furnace is the second wing of the Hellfire Citadel."},
{"BM-I", 	"[bB][mM]", 	"BM", "Black Morass", "The second instance in Caverns of Time", "--Beast Mastery", "A Hunter talent tree."},
{"CoT", 	"[cC][oO][tT]",	"CoT", "Caverns Of Time", "A BC and Wrath Instance Hub in Tanaris in Old World" }, 
{"MGT",		"[mM][gG][tT]", "MgT", "Magisters' Terrace", "A lvl 70 BC Instance"},

{"BT-raid",	"[bB][tT]", 	"BT", "Black Temple", "A level 70 raid instance in Outland"},
{"SWP-Instance", "[sS][wW][pP]","SWP", "Sun Well Plateau", 
	"A lvl 70 - 25man Instance in Oldworld, on the island North of Silvermoon City",
	"  Also: 'Shadow Word Pain', a priest damage spell" },
{"ZA-Instance", "[zZ][aA]", "Zul'Aman", "A lvl 70 10 man Raid Instance in Ghostlands near Silvermoon City"},
{"TK-Raid", 	"[tT][kK]", 	"TK", "Tempist Keep", "A Instance hub in Netherstorm, Outlands.", "This hub has 4 instances at it, with the last claiming the title 'TK', a 25man Raid Instance",},

{"EotS",	"[eE][oO][tT][sS]", "EoTS", "Eye Of The Storm", "A 20man Battleground added in BC"},

--Classic~~~~~~~~~~~~~~~`
{"VC",		"[vV][cC]",	"VC",	"Dead Mines", "Dead Mines is called VC, short for VanCleef the last boss in Deadmines", "This is so that it's not confused with Dire Maul a lvl ~55 instance"},
{"RFC", 	"[rR][fF][cC]", "RFC",	"Rage Fire Chasim"},
{"BFD-Instance","[bB][fF][dD]", "BFD",	"Blackfathom Deeps", "Blackfathom Deeps is a partially underwater dungeon in northwestern Ashenvale."},
{"BRD", 	"[bB][rR][dD]", "BRD",	"Blackrock Depths", "Lower instance at Blackrock Mountain, in Old World"},
{"BRD", 	"[bB][rR][sS]", "BRD",	"Blackrock Depths", "Upper instance at Blackrock Mountain, in Old World.", "Also is a 2 Part instance, UBRS and LBRS."},
{"DM", 		"[dD][mM]", 	"DM", 	"Dire Maul", "A Lvl ~55 Instance in Feralas. DM has 3 wings, usualy what wing is stated after.", "Not to be confused with Dead Mines"},
{"ZF", 		"[zZ][fF]", 	"ZF", 	"Zul'Farrak", "A lvl ~45 Old World Instance in Tanaris"},
{"RFK", 	"[rR][fF][kK]", "RFK", 	"Razorfen Kraul", "A lvl 20ish Old World Instance in 'The Barrens' "},
{"RFD", 	"[rR][fF][dD]", "RFD", 	"Razorfen Downs", "A lvl 30ish Old World Instance in 'The Barrens' "},
{"scholo",	"[sS][cC][hH][oO][lL][oO]", "Scholo", "Scholomance", " (SKOH-loh-mance), a lvl 60 5man Instance in Old World"},


{"MC",		"[mM][cC]", 	"MC", 	"Mind Control", "A Priest Spell", " When used as a location it would be in referece to", "Molten Core, a lvl 60 40man Raid Instance"}, 
{"ony", 	"[oO][nN][yY]", "Ony", 	"Onxia", "Old world 40man Raid Boss"},
{"ZG", 		"[Zz][gG]", 	"ZG", "Zul' Grub", "Old World, 20man Raid Instance in Strangle Thorn Vale"},
{"AQ20",	"[aA][qQ]20",	"AQ20", "Ruins of Ahn'Qiraj", "Ruins of Ahn'Qiraj is a 20-man Old World raid dungeon located in southern Silithus"},
{"BWL", 	"[bB][wW][lL]", "BWL", "Black Wing Lair", "A lvl 60, 40man Raid Instance in Old World"}, 
{"AQ40",	"[aA][qQ]40",	"AQ40", "Ruins of Ahn'Qiraj", "Temple of Ahn'Qiraj is a 40-man Old World raid dungeon located in southern Silithus"},

{"AB",		"[aA][bB]",	"AB", "Arathi Basin", "A 20man Battleground from Old World"},	--BG
	{"GM", 		"[gG][mM]",	"GM", "Great Many things", 
		" In Battlegrounds or PvP, can refer to 'Gold Mine', a node in Arathi Basin",
		" Guild Master, Leader of a guild",
		" Game Master, a Blizzard In-Game Customer Service Rep",},
	{"LM",		"[lL][mM]", 	"LM", "Lumber Mill", "A Resource Node in Arathi Basin"},
	{"ST",		"[sS][tT]", 	"ST", "Stables", "A Resource node in Arathi Basin"},

{"AV",		"[aA][vV]", 	"AB", "Alterc Vally", "A 40man battleground from Old World" },	--BG
{"WSG", 	"[wW][sS][gG]", "WSG", "Warsong Gulch", "A 15man Battleground from Old World"}, 
---------------
--General
---------------
{"DPS", 	"[dD][pP][sS]", "DPS", "Damage Per Second", "How much Damage done over time, generally in combat", "Also used to describe any class who's role is Damage Dealing"},
{"LFM", 	"[lL][fF][mM]", "LFM", "Looking For More", "Related to Looking for Group", "Generally used when your group is less than %10 filled, mainly used for groups doing Raids"},
{"LF", 		"[lL][fF]", 	"LF", "Looking For", "     Something to eat maybe?"},--This needs to come more or less last in the LF* serise
{"FP", 		"[fF][pP]", "FP", "Fligth Point or Path"},
{"FM",		"[fF][mM]", "FM", "Flight Master", }, 
{"MT", 		"[mM][tT]", 	"MT", "Many Things", 
	" 'Mis-Tell', when you say something in the wrong channel",
	" Main Tank, indicating somone who should bare the brunt of the damage in an instance",
	" Magisters' Terrace, a lvl 70 BC Instance", 
	" Mana Tombs, a lvl ~63 BC Instance", 

	},
{"OT-Role", 	"[oO][tT]", "OT", "Assistant to a Main Tank."},

--------------
--- Professions
---------------

{"JC", 		"[jJ][cC]", "JC", "Jewlcrafting"},
{"BS",		"[bB][sS]", "BS", "Blacksmithing", "Commonly a profession in World of Warcraft.", "Also, a resource node in Arathi Basin."},

--------------
--- Prominant Locations
---------------
{"LHC", 	"[lL][hH][cC]", "Lights Hope Chapel", "A 'Town' in Easter Plauge Lands where the Argent Dawn have their headquarters"},
{"EPL", 	"[eE][pP][lL]", "Eastern Plauge Lands", "Old world Zone, lvl 50+"},
{"WPL", 	"[wW][pP][lL]", "Western Plauge Lands", "Old world Zone, lvl 50+"},

}	--End of Definition File

do	--Special Case where the link itself needs to be modified so that detail of the origional message is not altered.
	local linkText = "LF%dM"
	AcronymGuide:RegisterSpecialCase({
		uid = "LF#M",
		regex = "%s[lL][fF]%d+[mM]%s",
		linkfunc = function(addon, leMessage, linkRepo)
			local count = tonumber( leMessage:match("%s[lL][fF](%d+)[mM]%s") or 0 )
			local link = addon:GetLink("LF#M", linkText:format(count) )
			tinsert(linkRepo, link)
			leMessage = leMessage:gsub("%s[lL][fF](%d+)[mM]%s", " \001\004"..#linkRepo.." ")
		
			return leMessage
		end,
		"Looking for X More",
	})
end

